﻿
#cs

convert Yahoo messages to EML format

1. Find ","rawEmail":" in file
2. Split by ","rawEmail":"
3. If last three characters is "}}, then trim last 3 characters

Replace \r\n with CRLF
Replace \n with LF
Replace \t with TAB

Replace &lt; and &gt;
Replace &#39; with '

#ce

Global $fileopen
Global $fileread
Global $writefile

; $filetype = InputBox ("Which file type?", "Which file type do you want  to merge... TXT, HTML, what?", "TXT")
$filetype = "TXT"
$filelist =  _GetFilesFolder_Rekursiv(@ScriptDir, $filetype, 0, 0)

For $i = 1 to $filelist[0]
; For $i = 1 to 5000

$fileopen = FileOpen ($filelist[$i], 16384)
$fileread = FileRead ($fileopen)

If NOT (StringInStr ($fileread, '","rawEmail":"')) Then
FileCopy ($filelist[$i], $filelist[$i] & "_empty")
ContinueLoop
EndIf

$mailstringsplit = StringSplit ($fileread, '","rawEmail":"', 1)

; Assume that message is well formed

$messageitself = StringTrimRight ($mailstringsplit[2], 3)

; MsgBox (0, "", $messageitself, 0)

$messageitself = StringReplace ($messageitself, "\r\n", @CRLF)
$messageitself = StringReplace ($messageitself, "\n", @LF)
$messageitself = StringReplace ($messageitself, "\t", @TAB)

$messageitself = StringReplace ($messageitself, "&lt;", "<")
$messageitself = StringReplace ($messageitself, "&gt;", ">")
$messageitself = StringReplace ($messageitself, "&#39;", "'")
$messageitself = StringReplace ($messageitself, "&quot;", '"')
$messageitself = StringReplace ($messageitself, "&apos;", "'")

; $messageitself = StringReplace ($messageitself, "&", "AMPERSAND")

$writefile = FileOpen ($filelist[$i] & "_.eml", 258)

FileWrite ($writefile, $messageitself)

FileClose ($writefile)
FileClose ($fileopen)

Next


;======================================================================================
; Function Name:   _GetFilesFolder_Rekursiv($sPath [, $sExt='*' [, $iDir=-1 [, $iRetType=0 ,[$sDelim='0']]]])
; Description:     recursive listing of files and/or folders
; Parameter(s):    $sPath     Basicpath of listing ('.' -current path, '..' -parent path)
;                  $sExt      Extension for file selection '*' or -1 for all (Default)
;                  $iDir      -1 files+Folder(Default), 0 only files, 1 only Folder
;      optional:   $iRetType  0 for Array, 1 for String as Return
;      optional:   $sDelim    Delimiter for string return
;                             0 -@CRLF (Default)  1 -@CR  2 -@LF  3 -';'  4 -'|'
; Return Value(s): Array (Default) or string with found pathes of files and/or folder
;                  Array[0] includes count of found files/folder
; Author(s):       BugFix (bugfix@autoit.de)
;=====================================================================================

Func _GetFilesFolder_Rekursiv($sPath, $sExt='*', $iDir=-1, $iRetType=0, $sDelim='0')
    Global $oFSO = ObjCreate('Scripting.FileSystemObject')
    Global $strFiles = ''
    Switch $sDelim
        Case '1'
            $sDelim = @CR
        Case '2'
            $sDelim = @LF
        Case '3'
            $sDelim = ';'
        Case '4'
            $sDelim = '|'
        Case Else
            $sDelim = @CRLF
    EndSwitch
    If ($iRetType < 0) Or ($iRetType > 1) Then $iRetType = 0
    If $sExt = -1 Then $sExt = '*'
    If ($iDir < -1) Or ($iDir > 1) Then $iDir = -1
    _ShowSubFolders($oFSO.GetFolder($sPath),$sExt,$iDir,$sDelim)
    If $iRetType = 0 Then
        Local $aOut
        $aOut = StringSplit(StringTrimRight($strFiles, StringLen($sDelim)), $sDelim, 1)
        If $aOut[1] = '' Then
            ReDim $aOut[1]
            $aOut[0] = 0
        EndIf
        Return $aOut
    Else
        Return StringTrimRight($strFiles, StringLen($sDelim))
    EndIf
EndFunc

Func _ShowSubFolders($Folder, $Ext='*', $Dir=-1, $Delim=@CRLF)
    If Not IsDeclared("strFiles") Then Global $strFiles = ''
    If ($Dir = -1) Or ($Dir = 0) Then
        For $file In $Folder.Files
            If $Ext <> '*' Then
                If StringRight($file.Name, StringLen($Ext)) = $Ext Then _
                    $strFiles &= $file.Path & $Delim
            Else
                $strFiles &= $file.Path & $Delim
            EndIf
        Next
    EndIf
    For $Subfolder In $Folder.SubFolders
        If ($Dir = -1) Or ($Dir = 1) Then $strFiles &= $Subfolder.Path & '\' & $Delim
        _ShowSubFolders($Subfolder, $Ext, $Dir, $Delim)
    Next
EndFunc
 